#include "inc/hw_ints.h"
#include "inc/hw_types.h"
#include "inc/hw_memmap.h"
#include "driverlib/gpio.h"
#include "driverlib/sysctl.h"
#include "driverlib/interrupt.h"
#include "driverlib/timer.h"
#include "driverlib/adc.h"
#include "driverlib/pwm.h"

// 1LEDI(1b)ON/OFF
void main(void)
{	
	// A/Dϊli[p
	unsigned long data;
	// ݒpϐ
	unsigned long ulPeriod;
	// ҂ԗp
	volatile unsigned long Loop;
	// NbN̐ݒ
	SysCtlClockSet(SYSCTL_SYSDIV_1 | SYSCTL_USE_OSC | SYSCTL_OSC_MAIN |
                   SYSCTL_XTAL_6MHZ);
    
    // gp|[g̑I@̓|[gDI
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
	SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
    // ADC0̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_ADC0);
    // PWM@\̎gp錾
    SysCtlPeripheralEnable(SYSCTL_PERIPH_PWM);
    // gpADC̎w
    ADCSequenceConfigure(ADC0_BASE, 3, ADC_TRIGGER_PROCESSOR, 0);
    // ADC̐ݒ
    ADCSequenceStepConfigure(ADC0_BASE, 3, 0,
                             ADC_CTL_CH1 | ADC_CTL_IE | ADC_CTL_END);
    // ADC0Lɂ
    ADCSequenceEnable(ADC0_BASE, 3);
    // PWM@\Ŏg|[g̎w
    GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_0);
    GPIOPinTypePWM(GPIO_PORTE_BASE, GPIO_PIN_1);
    // PWM̎w 1[ms]
    ulPeriod = SysCtlClockGet() / 1000;
	// PWMWFl[^[̐ݒ
    PWMGenConfigure(PWM_BASE, PWM_GEN_2,
                    PWM_GEN_MODE_UP_DOWN | PWM_GEN_MODE_NO_SYNC);
    // PWMWFl[^[̎ݒ
    PWMGenPeriodSet(PWM_BASE, PWM_GEN_2, ulPeriod);
	// PWM̃f[eB[̎w
    PWMPulseWidthSet(PWM_BASE, PWM_OUT_4, ulPeriod * 9 / 10);
    PWMPulseWidthSet(PWM_BASE, PWM_OUT_5, ulPeriod * 9 / 10);
    // PWM4̏o͂,PWM5̏o͂s
    PWMOutputState(PWM_BASE, PWM_OUT_4_BIT, true);
    PWMOutputState(PWM_BASE, PWM_OUT_5_BIT, false);
    // PWMJn
	PWMGenEnable(PWM_BASE, PWM_GEN_2);
	
    while(1)
    {
    	// A/DϊJn
    	ADCProcessorTrigger(ADC0_BASE, 3);
    	// A/Dϊl̎擾
    	ADCSequenceDataGet(ADC0_BASE, 3, &data);
    	for(Loop = 0; Loop < 20000; Loop++);
    	// A/Dϊ̒lɉăf[eB[ύX
    	PWMPulseWidthSet(PWM_BASE, PWM_OUT_4, ulPeriod * data / 1024);
    }
}
